

GRIDSTARTSIZE = 31
GRIDGROWTHINC = 30
TRISIZE = 60



ONBRS = [(0,0),(0,1),(1,0),(1,-1),(0,-1),(-1,0),(-1,1)]
ONBRINDEX = {(0,0): 0,
             (0,1): 1,
             (1,0): 2,
             (1,-1): 3,
             (0,-1): 4,
             (-1,0): 5,
             (-1,1): 6}

NBRFLIP = {(1,2):   (4,5),
           (2,3):   (5,6),
           (3,4):   (6,1),
           (4,5):   (1,2),
           (5,6):   (2,3),
           (6,1):   (3,4)}

SCALEDNBRS = [(0,0),(1,1),(2,-1),(1,-2),(-1,-1),(-2,1),(-1,2)]

SHAREDEDGES = {(1,1):   [(0,1), (1,0)],
               (2,-1):  [(1,0), (1,-1)],
               (1,-2):  [(1,-1), (0,-1)],
               (-1,-1): [(0,-1), (-1,0)],
               (-2,1):  [(-1,0), (-1,1)],
               (-1,2):  [(-1,1), (0,1)]}

NbrCount1 = {str([(1,2)]): {"Straight" : {"Add" : [(2,3),(3,4),(4,5),(5,6),(6,0),(0,1)],
                                   "NbrAdd" : [], 
                                   "NbrRemove" : [(1,2)]},
                            "V" : {"Add" : [(2,3),(3,4),(4,5),(5,6),(6,0),(0,1)],
                                   "NbrAdd" : [],
                                   "NbrRemove" : [(1,0),(0,2)]}
                            }
            }

NbrCount2 = {str([(1,2),(2,3)]): "foo",
             str([(1,2),(3,4)]): "foo2",
             str([(1,2),(4,5)]): "foo3"}

EdgePatterns = {0: [(0,6),(6,1),(1,2),(2,3),(3,4),(4,5),(5,0)],
                1: NbrCount1,
                2: NbrCount2,
                3: None,
                4: None,
                5: None,
                6: None}

def RotateEdges(edgeList, rotAmount):
    rotatedEdges = []
    for edge in edgeList:
        v1 = edge[0]
        if v1 > 0 and v1 < 7:
            v1 = ((v1 + (rotAmount-1)) % 6) + 1
        v2 = edge[1]
        if v2 > 0 and v2 < 7:
            v2 = ((v2 + (rotAmount-1)) % 6) + 1
        rotatedEdge = (v1, v2)
        rotatedEdges.append(rotatedEdge)
    return rotatedEdges

def RotateNbrGadgetNum(nbrNum, rot):
    if rot < 0:
        rot = rot + 6
    if nbrNum == 0:
        return 0
    else:
        nbrNum = nbrNum + rot
        if nbrNum > 6:
            nbrNum = (nbrNum % 6)
            if nbrNum == 0:
                nbrNum = 6
        return nbrNum
    